<?php

/*********************************************************************

 File Admin Ver 1.01 (2012/12/01)

*********************************************************************/

/********* ライセンス ************************************************

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 @Link http://www.php-labo.net/
 @Copyright(C) 2007-2012 PHP Labo
 @Author Knight <info at php-labo dot net>

*********************************************************************/

/********* 設定項目 *************************************************/

//プログラム格納ディレクトリのURL
define('HTTP_URL', 'http://www.example.com/file_admin/');

//管理者パスワード
define('ADMIN_PASSWORD', '1234');

//管理対象ディレクトリ
define('TARGET_DIR', 'test/');

//アスキーモードで扱うファイル
define('ASCII_FILE', '\.(txt|html|htm|log|js|css|ini|php|xml|htaccess|htpasswd)$');

//パスとして使用を許可する文字
define('PATH_CHARACTER', '^[\w\!\#\$\%\&\'\(\)\-\^\@\[\;\]\,\.\=\~\`\{\+\}\_\/]+$');

//新規作成時のディレクトリのパーミッション
define('PERMISSION_DIR', 0707);

//新規作成時のファイルのパーミッション
define('PERMISSION_FILE', 0606);

//セッションCookieの有効期限
define('SESSION_LIFETIME', 0);

//セッションのキャッシュ制御
define('SESSION_CACHE', 'none');

//プログラム実行時間の最大値
define('TIME_LIMIT', 0);

//プログラムの文字コード
define('SCRIPT_CHARSET', 'utf-8');

//プログラムファイル名
define('MAIN_FILE', 'index.php');

//CSSファイル名
define('CSS_FILE', 'common.css');

/********* メイン処理 ***********************************************/

//セッション開始
session();

//データ正規化
normalize();

//ログイン状態チェック
if (isloggedin()) {
	//モードに応じた処理を実行
	if (!isset($_REQUEST['mode'])) {
		$_REQUEST['mode'] = null;
	}
	if ($_REQUEST['mode'] == 'view_file') {
		admin_view_file();
	} elseif ($_REQUEST['mode'] == 'edit_file') {
		admin_edit_file();
	} elseif ($_REQUEST['mode'] == 'upload_file') {
		admin_upload_file();
	} elseif ($_REQUEST['mode'] == 'create_file') {
		admin_create_file();
	} elseif ($_REQUEST['mode'] == 'create_directory') {
		admin_create_directory();
	} elseif ($_REQUEST['mode'] == 'rename_file') {
		admin_rename_file();
	} elseif ($_REQUEST['mode'] == 'rename_directory') {
		admin_rename_directory();
	} elseif ($_REQUEST['mode'] == 'permission_file') {
		admin_permission_file();
	} elseif ($_REQUEST['mode'] == 'permission_directory') {
		admin_permission_directory();
	} elseif ($_REQUEST['mode'] == 'move_file') {
		admin_move_file();
	} elseif ($_REQUEST['mode'] == 'move_directory') {
		admin_move_directory();
	} elseif ($_REQUEST['mode'] == 'delete_file') {
		admin_delete_file();
	} elseif ($_REQUEST['mode'] == 'delete_directory') {
		admin_delete_directory();
	} elseif ($_REQUEST['mode'] == 'phpinfo') {
		admin_phpinfo();
	} elseif ($_REQUEST['mode'] == 'logout') {
		admin_logout();
	} else {
		admin_list();
	}
} else {
	admin();
}

exit;

/********* ユーザー定義関数 *****************************************/

/* ログイン状態チェック */
function isloggedin()
{
	if (isset($_POST['password'])) {
		//パスワード認証
		if ($_POST['password'] == ADMIN_PASSWORD) {
			$_SESSION['login'] = true;
		}

		header('Location: ' . HTTP_URL . MAIN_FILE . '?mode=default');

		exit;
	}

	if (isset($_SESSION['login']) and $_SESSION['login'] == true) {
		return true;
	} else {
		return false;
	}
}

/* 認証ページ */
function admin()
{
	//エラーメッセージ取得
	if (isset($_REQUEST['mode']) and $_REQUEST['mode'] == 'default') {
		$message = 'パスワードが違います。';
	} else {
		$message = 'パスワードを入力してください。';
	}

	//データ表示
	$js  = "window.onload = function()\n";
	$js .= "{\n";
	$js .= "\tdocument.getElementById('login_form').password.focus();\n";
	$js .= "}";

	print_header(CSS_FILE, $js);

	echo "<div id=\"admin\">\n";
	echo "<h2>パスワード認証</h2>\n";
	echo "<ul>\n";
	echo "<li>$message</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "\" method=\"post\" id=\"login_form\">\n";
	echo "<fieldset>\n";
	echo "<legend>認証フォーム</legend>\n";
	echo "<dl>\n";
	echo "<dt>パスワード</dt>\n";
	echo "<dd><input type=\"password\" name=\"password\" size=\"20\" value=\"\" /></dd>\n";
	echo "</dl>\n";
	echo "<p><input type=\"submit\" value=\"認証する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";
	echo "</div>\n";

	print_footer();

	return;
}

/* ファイル一覧 */
function admin_list()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}

	//親ディレクトリ取得
	$path = $_GET['path'];

	if (preg_match('/(.+)\/$/', $path, $matches)) {
		$path = $matches[1];
	}
	$pos = strrpos($path, '/');

	if ($pos > 0) {
		$parent = substr($path, 0, $pos) . '/';
	} else {
		$parent = '';
	}

	//ファイル取得
	$directories = array();
	$files       = array();

	if ($dir = scandir(TARGET_DIR . $_GET['path'])) {
		foreach ($dir as $data) {
			if ($data == '.' or $data == '..') {
				continue;
			}

			if (is_dir(TARGET_DIR . $_GET['path'] . $data)) {
				$directories[] = array(
					'name'       => $data,
					'datetime'   => date('Y/m/d H:i:s', filemtime(TARGET_DIR . $_GET['path'] . $data)),
					'permission' => substr(sprintf('%o', fileperms(TARGET_DIR . $_GET['path'] . $data)), -4),
					'owner'      => fileowner(TARGET_DIR . $_GET['path'] . $data)
				);
			} else {
				list($width, $height, $size) = get_file(TARGET_DIR . $_GET['path'] . $data);

				$files[] = array(
					'name'       => $data,
					'datetime'   => date('Y/m/d H:i:s', filemtime(TARGET_DIR . $_GET['path'] . $data)),
					'permission' => substr(sprintf('%o', fileperms(TARGET_DIR . $_GET['path'] . $data)), -4),
					'owner'      => fileowner(TARGET_DIR . $_GET['path'] . $data),
					'width'      => $width,
					'height'     => $height,
					'size'       => $size
				);
			}
		}
	} else {
		error('ファイル管理ディレクトリ ' . TARGET_DIR . $_GET['path'] . ' を開けません。');
	}

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">ファイル一覧</a></li>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "?mode=phpinfo\">phpinfo()</a></li>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "?mode=logout\">ログアウト</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ファイル一覧</h2>\n";

	if (isset($_GET['exec'])) {
		echo "<ul>\n";

		if ($_GET['exec'] == 'edit_file') {
			echo "<li>ファイルを編集しました。</li>\n";
		} elseif ($_GET['exec'] == 'upload_file') {
			echo "<li>ファイルをアップロードしました。</li>\n";
		} elseif ($_GET['exec'] == 'create_file') {
			echo "<li>ファイルを新規に作成しました。</li>\n";
		} elseif ($_GET['exec'] == 'create_directory') {
			echo "<li>ディレクトリを新規に作成しました。</li>\n";
		} elseif ($_GET['exec'] == 'rename_file') {
			echo "<li>ファイル名を変更しました。</li>\n";
		} elseif ($_GET['exec'] == 'rename_directory') {
			echo "<li>ディレクトリ名を変更しました。</li>\n";
		} elseif ($_GET['exec'] == 'permission_file') {
			echo "<li>ファイルの属性を変更しました。</li>\n";
		} elseif ($_GET['exec'] == 'permission_directory') {
			echo "<li>ディレクトリの属性を変更しました。</li>\n";
		} elseif ($_GET['exec'] == 'move_file') {
			echo "<li>ファイルを移動しました。</li>\n";
		} elseif ($_GET['exec'] == 'move_directory') {
			echo "<li>ディレクトリを移動しました。</li>\n";
		} elseif ($_GET['exec'] == 'delete_file') {
			echo "<li>ファイルを削除しました。</li>\n";
		} elseif ($_GET['exec'] == 'delete_directory') {
			echo "<li>ディレクトリを削除しました。</li>\n";
		}

		echo "</ul>\n";
	}

	echo "<ul>\n";
	echo "<li><code>" . TARGET_DIR . $_GET['path'] . "</code> に登録されたファイルは以下のとおりです。</li>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "?mode=upload_file&amp;path=" . urlencode($_GET['path']) . "\">" . ($_GET['path'] ? 'この階層に' : '') . "ファイルをアップロードする</a></li>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "?mode=create_file&amp;path=" . urlencode($_GET['path']) . "\">" . ($_GET['path'] ? 'この階層に' : '') . "ファイルを作成する</a></li>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "?mode=create_directory&amp;path=" . urlencode($_GET['path']) . "\">" . ($_GET['path'] ? 'この階層に' : '') . "ディレクトリを作成する</a></li>\n";
	echo "</ul>\n";
	echo "<table summary=\"ファイル一覧\">\n";
	echo "<tr>\n";
	echo "<th>ファイル</th>\n";
	echo "<th>サイズ</th>\n";
	echo "<th>更新日時</th>\n";
	echo "<th>属性</th>\n";
	echo "<th>所有者</th>\n";
	echo "<th>作業</th>\n";
	echo "</tr>\n";

	if ($_GET['path'] != '') {
		echo "<tr>\n";
		echo "<td><code>■ ..</code></td>\n";
		echo "<td></td>\n";
		echo "<td></td>\n";
		echo "<td></td>\n";
		echo "<td></td>\n";
		echo "<td>\n";
		echo "<a href=\"" . HTTP_URL . MAIN_FILE . "?path=" . urlencode($parent) . "\">上の階層へ</a>\n";
		echo "</td>\n";
		echo "</tr>\n";
	}
	foreach ($directories as $directory) {
		echo "<tr>\n";
		echo "<td><code>■ " . $directory['name'] . "</code></td>\n";
		echo "<td></td>\n";
		echo "<td>" . $directory['datetime'] . "</td>\n";
		echo "<td>" . $directory['permission'] . "</td>\n";
		echo "<td>" . $directory['owner'] . "</td>\n";
		echo "<td>\n";
		echo "<a href=\"" . HTTP_URL . MAIN_FILE . "?path=" . urlencode($_GET['path'] . $directory['name'] . '/') . "\">開く</a>\n";
		echo "<a href=\"" . HTTP_URL . MAIN_FILE . "?mode=rename_directory&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($directory['name'] . '/') . "\">名前変更</a>\n";
		echo "<a href=\"" . HTTP_URL . MAIN_FILE . "?mode=permission_directory&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($directory['name'] . '/') . "\">属性変更</a>\n";
		echo "<a href=\"" . HTTP_URL . MAIN_FILE . "?mode=move_directory&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($directory['name'] . '/') . "\">移動</a>\n";
		echo "<a href=\"" . HTTP_URL . MAIN_FILE . "?mode=delete_directory&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($directory['name'] . '/') . "\">削除</a>\n";
		echo "</td>\n";
		echo "</tr>\n";
	}
	foreach ($files as $file) {
		if ($file['size'] >= 1024) {
			$file['size'] = intval($file['size'] / 1024) . 'KB';
		} else {
			$file['size'] = $file['size'] . 'B';
		}

		echo "<tr>\n";
		echo "<td><code>□ " . $file['name'] . "</code></td>\n";
		echo "<td>" . $file['size'] . "</td>\n";
		echo "<td>" . $file['datetime'] . "</td>\n";
		echo "<td>" . $file['permission'] . "</td>\n";
		echo "<td>" . $file['owner'] . "</td>\n";
		echo "<td>\n";
		echo "<a href=\"" . HTTP_URL . MAIN_FILE . "?mode=view_file&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($file['name']) . "\">表示</a>\n";
		echo "<a href=\"" . HTTP_URL . MAIN_FILE . "?mode=rename_file&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($file['name']) . "\">名前変更</a>\n";
		echo "<a href=\"" . HTTP_URL . MAIN_FILE . "?mode=permission_file&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($file['name']) . "\">属性変更</a>\n";
		echo "<a href=\"" . HTTP_URL . MAIN_FILE . "?mode=move_file&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($file['name']) . "\">移動</a>\n";
		echo "<a href=\"" . HTTP_URL . MAIN_FILE . "?mode=delete_file&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($file['name']) . "\">削除</a>\n";
		echo "</td>\n";
		echo "</tr>\n";
	}

	echo "</table>\n";

	print_footer();

	return;
}

/* ファイル表示 */
function admin_view_file()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}
	if (!isset($_GET['name']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['name']) or preg_match('/\.\.\//', $_GET['name'])) {
		$_GET['name'] = null;
	}

	//アスキーモードで扱うファイルでなければリダイレクト
	if (!preg_match('/' . ASCII_FILE . '/i', $_GET['name'])) {
		//リダイレクト
		header('Location: ' . HTTP_URL . TARGET_DIR . str_replace('%2F', '/', urlencode($_GET['path'] . $_GET['name'])));

		exit;
	}

	//アスキーモードで扱うファイルなら読み込み
	$text = file_get_contents(TARGET_DIR . $_GET['path'] . $_GET['name']);

	if ($text === false) {
		error('ファイル ' . TARGET_DIR . $_GET['path'] . $_GET['name'] . ' を読み込めません。');
	}

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ファイル表示</h2>\n";
	echo "<ul>\n";
	echo "<li>ファイル <code>" . TARGET_DIR . $_GET['path'] . $_GET['name'] . "</code> の内容は以下のとおりです。</li>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "?mode=edit_file&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($_GET['name']) . "\">このファイルを編集する</a></li>\n";
	echo "</ul>\n";
	echo "<pre>" . $text . "</pre>\n";

	print_footer();

	return;
}

/* ファイル編集 */
function admin_edit_file()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}
	if (!isset($_GET['name']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['name']) or preg_match('/\.\.\//', $_GET['name'])) {
		$_GET['name'] = null;
	}

	if (isset($_POST['exec']) and $_POST['exec'] == 'edit_file') {
		//ワンタイムトークン比較
		if (!token_check()) {
			error('不正なアクセスです。');
		}

		//入力データ検証
		if ($_POST['path'] != '' and !preg_match('/' . PATH_CHARACTER . '/', $_POST['path'])) {
			error('パスは半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('パスの入力内容が不正です。');
		}
		if ($_POST['name'] == '') {
			error('ファイル名が入力されていません。');
		} elseif (!preg_match('/' . PATH_CHARACTER . '/', $_POST['name'])) {
			error('ファイル名は半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['name'])) {
			error('ファイル名の入力内容が不正です。');
		} elseif (mb_strlen($_POST['name'], 'UTF-8') > 255) {
			error('ファイル名は255文字以内で入力してください。');
		}

		//ファイル編集
		if (file_put_contents(TARGET_DIR . $_POST['path'] . $_POST['name'], $_POST['text']) === false) {
			error('ファイル ' . TARGET_DIR . $_POST['path'] . $_POST['name'] . ' に書き込めません。');
		}

		//リダイレクト
		header('Location: ' . HTTP_URL . MAIN_FILE . '?exec=' . $_POST['exec'] . '&path=' . str_replace('%2F', '/', urlencode($_POST['path'])));

		exit;
	}

	//アスキーモードで扱うファイルでなければリダイレクト
	if (!preg_match('/' . ASCII_FILE . '/i', $_GET['name'])) {
		//リダイレクト
		header('Location: ' . HTTP_URL . TARGET_DIR . str_replace('%2F', '/', urlencode($_GET['path'] . $_GET['name'])));

		exit;
	}

	//アスキーモードで扱うファイルなら読み込み
	$text = file_get_contents(TARGET_DIR . $_GET['path'] . $_GET['name']);

	if ($text === false) {
		error('ファイル ' . TARGET_DIR . $_GET['path'] . $_GET['name'] . ' を読み込めません。');
	}

	//ワンタイムトークン作成
	$token = token_create();

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ファイル表示</h2>\n";
	echo "<ul>\n";
	echo "<li>ファイル <code>" . TARGET_DIR . $_GET['path'] . $_GET['name'] . "</code> を編集します。</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "?mode=edit_file&amp;path=" . urlencode($_GET['path']) . "\" method=\"post\">\n";
	echo "<fieldset>\n";
	echo "<legend>ファイル編集フォーム</legend>\n";
	echo "<input type=\"hidden\" name=\"token\" value=\"" . $token . "\" />\n";
	echo "<input type=\"hidden\" name=\"exec\" value=\"edit_file\" />\n";
	echo "<input type=\"hidden\" name=\"path\" value=\"" . $_GET['path'] . "\" />\n";
	echo "<input type=\"hidden\" name=\"name\" value=\"" . $_GET['name'] . "\" />\n";
	echo "<dl>\n";
	echo "<dt>ファイル</dt>\n";
	echo "<dd><textarea name=\"text\" cols=\"50\" rows=\"10\">" . $text . "</textarea></dd>\n";
	echo "</dl>\n";
	echo "<p><input type=\"submit\" value=\"編集する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";

	print_footer();

	return;
}

/* ファイルアップロード */
function admin_upload_file()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}

	if (isset($_POST['exec']) and $_POST['exec'] == 'upload_file') {
		//ワンタイムトークン比較
		if (!token_check()) {
			error('不正なアクセスです。');
		}

		//入力データ検証
		if ($_POST['path'] != '' and !preg_match('/' . PATH_CHARACTER . '/', $_POST['path'])) {
			error('パスは半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('パスの入力内容が不正です。');
		}

		//ファイルアップロード
		$file_count = count($_FILES['files']['tmp_name']);
		$file_flag  = false;

		for ($i = 0; $i < $file_count; $i++) {
			if (is_uploaded_file($_FILES['files']['tmp_name'][$i])) {
				if (!preg_match('/' . PATH_CHARACTER . '/', $_FILES['files']['name'][$i])) {
					error('ファイル名は半角英数字で指定してください。');
				}
				if (is_file(TARGET_DIR . $_POST['path'] . $_FILES['files']['name'][$i])) {
					error('ファイル「' . $_FILES['files']['name'][$i] . '」はすでに存在します。');
				}

				if (move_uploaded_file($_FILES['files']['tmp_name'][$i], TARGET_DIR . $_POST['path'] . $_FILES['files']['name'][$i])) {
					chmod(TARGET_DIR . $_POST['path'] . $_FILES['files']['name'][$i], PERMISSION_FILE);

					if (preg_match('/' . ASCII_FILE . '/i', $_FILES['files']['name'][$i])) {
						$data = file_get_contents(TARGET_DIR . $_POST['path'] . $_FILES['files']['name'][$i]);

						if ($data) {
							if (file_put_contents(TARGET_DIR . $_POST['path'] . $_FILES['files']['name'][$i], unify($data)) === false) {
								error('ファイルの改行コードを変更できません。');
							}
						}
					}

					$file_flag = true;
				} else {
					error('ファイルをアップロードできません。');
				}
			}
		}
		if ($file_flag == false) {
			error('ファイルを選択してください。');
		}

		//リダイレクト
		header('Location: ' . HTTP_URL . MAIN_FILE . '?exec=' . $_POST['exec'] . '&path=' . str_replace('%2F', '/', urlencode($_POST['path'])));

		exit;
	}

	//ワンタイムトークン作成
	$token = token_create();

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ファイルアップロード</h2>\n";
	echo "<ul>\n";
	echo "<li><code>" . TARGET_DIR . $_GET['path'] . "</code> にアップロードしたいファイルを選択してください。</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "?mode=upload_file&amp;path=" . urlencode($_GET['path']) . "\" method=\"post\" enctype=\"multipart/form-data\">\n";
	echo "<fieldset>\n";
	echo "<legend>ファイルアップロードフォーム</legend>\n";
	echo "<input type=\"hidden\" name=\"token\" value=\"" . $token . "\" />\n";
	echo "<input type=\"hidden\" name=\"exec\" value=\"upload_file\" />\n";
	echo "<input type=\"hidden\" name=\"path\" value=\"" . $_GET['path'] . "\" />\n";
	echo "<dl>\n";
	echo "<dt>ファイル1</dt>\n";
	echo "<dd><input type=\"file\" name=\"files[]\" size=\"30\" /></dd>\n";
	echo "<dt>ファイル2</dt>\n";
	echo "<dd><input type=\"file\" name=\"files[]\" size=\"30\" /></dd>\n";
	echo "<dt>ファイル3</dt>\n";
	echo "<dd><input type=\"file\" name=\"files[]\" size=\"30\" /></dd>\n";
	echo "</dl>\n";
	echo "<p><input type=\"submit\" value=\"作成する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";

	print_footer();

	return;
}

/* ファイル作成 */
function admin_create_file()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}

	if (isset($_POST['exec']) and $_POST['exec'] == 'create_file') {
		//ワンタイムトークン比較
		if (!token_check()) {
			error('不正なアクセスです。');
		}

		//入力データ検証
		if ($_POST['path'] != '' and !preg_match('/' . PATH_CHARACTER . '/', $_POST['path'])) {
			error('パスは半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('パスの入力内容が不正です。');
		}
		if ($_POST['name'] == '') {
			error('ファイル名が入力されていません。');
		} elseif (!preg_match('/' . PATH_CHARACTER . '/', $_POST['name'])) {
			error('ファイル名は半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('ファイル名の入力内容が不正です。');
		} elseif (mb_strlen($_POST['name'], 'UTF-8') > 255) {
			error('ファイル名は255文字以内で入力してください。');
		} elseif (is_file(TARGET_DIR . $_POST['path'] . $_POST['name'])) {
			error('ファイル' . $_POST['name'] . 'はすでに存在します。');
		}

		//ファイル作成
		if (file_put_contents(TARGET_DIR . $_POST['path'] . $_POST['name'], '') === false) {
			error('ファイル ' . TARGET_DIR . $_POST['path'] . $_POST['name'] . ' を作成できません。');
		}

		//パーミッション設定
		chmod(TARGET_DIR . $_POST['path'] . $_POST['name'], PERMISSION_FILE);

		//リダイレクト
		header('Location: ' . HTTP_URL . MAIN_FILE . '?exec=' . $_POST['exec'] . '&path=' . str_replace('%2F', '/', urlencode($_POST['path'])));

		exit;
	}

	//ワンタイムトークン作成
	$token = token_create();

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ファイル作成</h2>\n";
	echo "<ul>\n";
	echo "<li><code>" . TARGET_DIR . $_GET['path'] . "</code> に作成したいファイル名を入力してください。</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "?mode=create_file&amp;path=" . urlencode($_GET['path']) . "\" method=\"post\">\n";
	echo "<fieldset>\n";
	echo "<legend>ファイル作成フォーム</legend>\n";
	echo "<input type=\"hidden\" name=\"token\" value=\"" . $token . "\" />\n";
	echo "<input type=\"hidden\" name=\"exec\" value=\"create_file\" />\n";
	echo "<input type=\"hidden\" name=\"path\" value=\"" . $_GET['path'] . "\" />\n";
	echo "<dl>\n";
	echo "<dt>ファイル名</dt>\n";
	echo "<dd><input type=\"text\" name=\"name\" size=\"30\" value=\"\" /></dd>\n";
	echo "</dl>\n";
	echo "<p><input type=\"submit\" value=\"作成する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";

	print_footer();

	return;
}

/* ディレクトリ作成 */
function admin_create_directory()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}

	if (isset($_POST['exec']) and $_POST['exec'] == 'create_directory') {
		//ワンタイムトークン比較
		if (!token_check()) {
			error('不正なアクセスです。');
		}

		//入力データ検証
		if ($_POST['path'] != '' and !preg_match('/' . PATH_CHARACTER . '/', $_POST['path'])) {
			error('パスは半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('パスの入力内容が不正です。');
		}
		if ($_POST['name'] == '') {
			error('ディレクトリ名が入力されていません。');
		} elseif (!preg_match('/' . PATH_CHARACTER . '/', $_POST['name'])) {
			error('ディレクトリ名は半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['name'])) {
			error('ディレクトリ名の入力内容が不正です。');
		} elseif (mb_strlen($_POST['name'], 'UTF-8') > 255) {
			error('ディレクトリ名は255文字以内で入力してください。');
		} elseif (is_dir(TARGET_DIR . $_POST['path'] . $_POST['name'])) {
			error('ディレクトリ' . $_POST['name'] . 'はすでに存在します。');
		}

		//ディレクトリ作成
		if (mkdir(TARGET_DIR . $_POST['path'] . $_POST['name'], PERMISSION_DIR) === false) {
			error('ディレクトリ ' . TARGET_DIR . $_POST['path'] . $_POST['name'] . ' を作成できません。');
		}

		//リダイレクト
		header('Location: ' . HTTP_URL . MAIN_FILE . '?exec=' . $_POST['exec'] . '&path=' . str_replace('%2F', '/', urlencode($_POST['path'])));

		exit;
	}

	//ワンタイムトークン作成
	$token = token_create();

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ディレクトリ作成</h2>\n";
	echo "<ul>\n";
	echo "<li><code>" . TARGET_DIR . $_GET['path'] . "</code> に作成したいディレクトリ名を入力してください。</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "?mode=create_directory&amp;path=" . urlencode($_GET['path']) . "\" method=\"post\">\n";
	echo "<fieldset>\n";
	echo "<legend>ディレクトリ作成フォーム</legend>\n";
	echo "<input type=\"hidden\" name=\"token\" value=\"" . $token . "\" />\n";
	echo "<input type=\"hidden\" name=\"exec\" value=\"create_directory\" />\n";
	echo "<input type=\"hidden\" name=\"path\" value=\"" . $_GET['path'] . "\" />\n";
	echo "<dl>\n";
	echo "<dt>ディレクトリ名</dt>\n";
	echo "<dd><input type=\"text\" name=\"name\" size=\"30\" value=\"\" /></dd>\n";
	echo "</dl>\n";
	echo "<p><input type=\"submit\" value=\"作成する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";

	print_footer();

	return;
}

/* ファイル名変更 */
function admin_rename_file()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}
	if (!isset($_GET['name']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['name']) or preg_match('/\.\.\//', $_GET['name'])) {
		$_GET['name'] = null;
	}

	if (isset($_POST['exec']) and $_POST['exec'] == 'rename_file') {
		//ワンタイムトークン比較
		if (!token_check()) {
			error('不正なアクセスです。');
		}

		//入力データ検証
		if ($_POST['path'] != '' and !preg_match('/' . PATH_CHARACTER . '/', $_POST['path'])) {
			error('パスは半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('パスの入力内容が不正です。');
		}
		if ($_POST['name'] == '') {
			error('ファイル名が入力されていません。');
		} elseif (!preg_match('/' . PATH_CHARACTER . '/', $_POST['name'])) {
			error('ファイル名は半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['name'])) {
			error('ファイル名の入力内容が不正です。');
		} elseif (mb_strlen($_POST['name'], 'UTF-8') > 255) {
			error('ファイル名は255文字以内で入力してください。');
		} elseif (is_file(TARGET_DIR . $_POST['path'] . $_POST['name'])) {
			error('ファイル' . $_POST['name'] . 'はすでに存在します。');
		}

		//ファイル名変更
		if (!rename(TARGET_DIR . $_POST['path'] . $_GET['name'], TARGET_DIR . $_POST['path'] . $_POST['name'])) {
			error('ファイル ' . TARGET_DIR . $_POST['path'] . $_GET['name'] . ' の名前を変更できません。');
		}

		//リダイレクト
		header('Location: ' . HTTP_URL . MAIN_FILE . '?exec=' . $_POST['exec'] . '&path=' . str_replace('%2F', '/', urlencode($_POST['path'])));

		exit;
	}

	//ワンタイムトークン作成
	$token = token_create();

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ファイル名変更</h2>\n";
	echo "<ul>\n";
	echo "<li>ファイル <code>" . TARGET_DIR . $_GET['path'] . $_GET['name'] . "</code> の名前を変更します。</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "?mode=rename_file&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($_GET['name']) . "\" method=\"post\">\n";
	echo "<fieldset>\n";
	echo "<legend>ファイル名変更フォーム</legend>\n";
	echo "<input type=\"hidden\" name=\"token\" value=\"" . $token . "\" />\n";
	echo "<input type=\"hidden\" name=\"exec\" value=\"rename_file\" />\n";
	echo "<input type=\"hidden\" name=\"path\" value=\"" . $_GET['path'] . "\" />\n";
	echo "<dl>\n";
	echo "<dt>ファイル名</dt>\n";
	echo "<dd><input type=\"text\" name=\"name\" size=\"30\" value=\"" . $_GET['name'] . "\" /></dd>\n";
	echo "</dl>\n";
	echo "<p><input type=\"submit\" value=\"変更する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";

	print_footer();

	return;
}

/* ディレクトリ名変更 */
function admin_rename_directory()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}
	if (!isset($_GET['name']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['name']) or preg_match('/\.\.\//', $_GET['name'])) {
		$_GET['name'] = null;
	}

	if (isset($_POST['exec']) and $_POST['exec'] == 'rename_directory') {
		//ワンタイムトークン比較
		if (!token_check()) {
			error('不正なアクセスです。');
		}

		//入力データ検証
		if ($_POST['path'] != '' and !preg_match('/' . PATH_CHARACTER . '/', $_POST['path'])) {
			error('パスは半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('パスの入力内容が不正です。');
		}
		if ($_POST['name'] == '') {
			error('ディレクトリ名が入力されていません。');
		} elseif (!preg_match('/' . PATH_CHARACTER . '/', $_POST['name'])) {
			error('ディレクトリ名は半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['name'])) {
			error('ディレクトリ名の入力内容が不正です。');
		} elseif (mb_strlen($_POST['name'], 'UTF-8') > 255) {
			error('ディレクトリ名は255文字以内で入力してください。');
		} elseif (is_dir(TARGET_DIR . $_POST['path'] . $_POST['name'])) {
			error('ディレクトリ' . $_POST['name'] . 'はすでに存在します。');
		}

		//ディレクトリ名変更
		if (!rename(TARGET_DIR . $_POST['path'] . $_GET['name'], TARGET_DIR . $_POST['path'] . $_POST['name'])) {
			error('ディレクトリ ' . TARGET_DIR . $_POST['path'] . $_GET['name'] . ' の名前を変更できません。');
		}

		//リダイレクト
		header('Location: ' . HTTP_URL . MAIN_FILE . '?exec=' . $_POST['exec'] . '&path=' . str_replace('%2F', '/', urlencode($_POST['path'])));

		exit;
	}

	//ワンタイムトークン作成
	$token = token_create();

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ディレクトリ名変更</h2>\n";
	echo "<ul>\n";
	echo "<li>ディレクトリ <code>" . TARGET_DIR . $_GET['path'] . preg_replace('/\/$/', '', $_GET['name']) . "/</code> の名前を変更します。</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "?mode=rename_directory&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($_GET['name']) . "\" method=\"post\">\n";
	echo "<fieldset>\n";
	echo "<legend>ディレクトリ名変更フォーム</legend>\n";
	echo "<input type=\"hidden\" name=\"token\" value=\"" . $token . "\" />\n";
	echo "<input type=\"hidden\" name=\"exec\" value=\"rename_directory\" />\n";
	echo "<input type=\"hidden\" name=\"path\" value=\"" . $_GET['path'] . "\" />\n";
	echo "<dl>\n";
	echo "<dt>ディレクトリ名</dt>\n";
	echo "<dd><input type=\"text\" name=\"name\" size=\"30\" value=\"" . preg_replace('/\/$/', '', $_GET['name']) . "\" /></dd>\n";
	echo "</dl>\n";
	echo "<p><input type=\"submit\" value=\"変更する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";

	print_footer();

	return;
}

/* ファイル属性変更 */
function admin_permission_file()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}
	if (!isset($_GET['name']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['name']) or preg_match('/\.\.\//', $_GET['name'])) {
		$_GET['name'] = null;
	}

	if (isset($_POST['exec']) and $_POST['exec'] == 'permission_file') {
		//ワンタイムトークン比較
		if (!token_check()) {
			error('不正なアクセスです。');
		}

		//入力データ検証
		if ($_POST['path'] != '' and !preg_match('/' . PATH_CHARACTER . '/', $_POST['path'])) {
			error('パスは半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('パスの入力内容が不正です。');
		}
		if ($_POST['name'] == '') {
			error('ファイル名が入力されていません。');
		} elseif (!preg_match('/' . PATH_CHARACTER . '/', $_POST['name'])) {
			error('ファイル名は半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['name'])) {
			error('ファイル名の入力内容が不正です。');
		} elseif (mb_strlen($_POST['name'], 'UTF-8') > 255) {
			error('ファイル名は255文字以内で入力してください。');
		}
		if ($_POST['permission'] == '') {
			error('ファイル属性が入力されていません。');
		} elseif (!preg_match('/^\d\d\d$/', $_POST['permission'])) {
			error('ファイル属性は3桁の半角数字で入力してください。');
		}

		//ファイル属性変更
		if (!chmod(TARGET_DIR . $_POST['path'] . $_POST['name'], octdec($_POST['permission']))) {
			error('ファイル ' . TARGET_DIR . $_POST['path'] . $_POST['name'] . ' の属性を変更できません。');
		}

		//リダイレクト
		header('Location: ' . HTTP_URL . MAIN_FILE . '?exec=' . $_POST['exec'] . '&path=' . str_replace('%2F', '/', urlencode($_POST['path'])));

		exit;
	}

	//ワンタイムトークン作成
	$token = token_create();

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ファイル属性変更</h2>\n";
	echo "<ul>\n";
	echo "<li>ファイル <code>" . TARGET_DIR . $_GET['path'] . $_GET['name'] . "</code> の属性を変更します。</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "?mode=permission_file&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($_GET['name']) . "\" method=\"post\">\n";
	echo "<fieldset>\n";
	echo "<legend>ファイル属性変更フォーム</legend>\n";
	echo "<input type=\"hidden\" name=\"token\" value=\"" . $token . "\" />\n";
	echo "<input type=\"hidden\" name=\"exec\" value=\"permission_file\" />\n";
	echo "<input type=\"hidden\" name=\"path\" value=\"" . $_GET['path'] . "\" />\n";
	echo "<input type=\"hidden\" name=\"name\" value=\"" . $_GET['name'] . "\" />\n";
	echo "<dl>\n";
	echo "<dt>ファイル属性</dt>\n";
	echo "<dd><input type=\"text\" name=\"permission\" size=\"30\" value=\"" . substr(sprintf('%o', fileperms(TARGET_DIR . $_GET['path'] . $_GET['name'])), -3) . "\" /></dd>\n";
	echo "</dl>\n";
	echo "<p><input type=\"submit\" value=\"変更する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";

	print_footer();

	return;
}

/* ディレクトリ属性変更 */
function admin_permission_directory()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}
	if (!isset($_GET['name']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['name']) or preg_match('/\.\.\//', $_GET['name'])) {
		$_GET['name'] = null;
	}

	if (isset($_POST['exec']) and $_POST['exec'] == 'permission_directory') {
		//ワンタイムトークン比較
		if (!token_check()) {
			error('不正なアクセスです。');
		}

		//入力データ検証
		if ($_POST['path'] != '' and !preg_match('/' . PATH_CHARACTER . '/', $_POST['path'])) {
			error('パスは半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('パスの入力内容が不正です。');
		}
		if ($_POST['name'] == '') {
			error('ディレクトリ名が入力されていません。');
		} elseif (!preg_match('/' . PATH_CHARACTER . '/', $_POST['name'])) {
			error('ディレクトリ名は半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['name'])) {
			error('ディレクトリ名の入力内容が不正です。');
		} elseif (mb_strlen($_POST['name'], 'UTF-8') > 255) {
			error('ディレクトリ名は255文字以内で入力してください。');
		}
		if ($_POST['permission'] == '') {
			error('ディレクトリ属性が入力されていません。');
		} elseif (!preg_match('/^\d\d\d$/', $_POST['permission'])) {
			error('ディレクトリ属性は3桁の半角数字で入力してください。');
		}

		//ディレクトリ属性変更
		if (!chmod(TARGET_DIR . $_POST['path'] . $_POST['name'], octdec($_POST['permission']))) {
			error('ディレクトリ ' . TARGET_DIR . $_POST['path'] . $_POST['name'] . ' の属性を変更できません。');
		}

		//リダイレクト
		header('Location: ' . HTTP_URL . MAIN_FILE . '?exec=' . $_POST['exec'] . '&path=' . str_replace('%2F', '/', urlencode($_POST['path'])));

		exit;
	}

	//ワンタイムトークン作成
	$token = token_create();

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ディレクトリ属性変更</h2>\n";
	echo "<ul>\n";
	echo "<li>ディレクトリ <code>" . TARGET_DIR . $_GET['path'] . preg_replace('/\/$/', '', $_GET['name']) . "/</code> の属性を変更します。</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "?mode=permission_directory&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($_GET['name']) . "\" method=\"post\">\n";
	echo "<fieldset>\n";
	echo "<legend>ディレクトリ属性変更フォーム</legend>\n";
	echo "<input type=\"hidden\" name=\"token\" value=\"" . $token . "\" />\n";
	echo "<input type=\"hidden\" name=\"exec\" value=\"permission_directory\" />\n";
	echo "<input type=\"hidden\" name=\"path\" value=\"" . $_GET['path'] . "\" />\n";
	echo "<input type=\"hidden\" name=\"name\" value=\"" . $_GET['name'] . "\" />\n";
	echo "<dl>\n";
	echo "<dt>ディレクトリ属性</dt>\n";
	echo "<dd><input type=\"text\" name=\"permission\" size=\"30\" value=\"" . substr(sprintf('%o', fileperms(TARGET_DIR . $_GET['path'] . $_GET['name'])), -3) . "\" /></dd>\n";
	echo "</dl>\n";
	echo "<p><input type=\"submit\" value=\"変更する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";

	print_footer();

	return;
}

/* ファイル移動 */
function admin_move_file()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}
	if (!isset($_GET['name']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['name']) or preg_match('/\.\.\//', $_GET['name'])) {
		$_GET['name'] = null;
	}

	if (isset($_POST['exec']) and $_POST['exec'] == 'move_file') {
		//ワンタイムトークン比較
		if (!token_check()) {
			error('不正なアクセスです。');
		}

		//入力データ検証
		if ($_POST['path'] != '' and !preg_match('/' . PATH_CHARACTER . '/', $_POST['path'])) {
			error('パスは半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('パスの入力内容が不正です。');
		}
		if ($_POST['name'] == '') {
			error('ファイル名が入力されていません。');
		} elseif (!preg_match('/' . PATH_CHARACTER . '/', $_POST['name'])) {
			error('ファイル名は半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['name'])) {
			error('ファイル名の入力内容が不正です。');
		} elseif (mb_strlen($_POST['name'], 'UTF-8') > 255) {
			error('ファイル名は255文字以内で入力してください。');
		}
		if (is_file(TARGET_DIR . $_POST['path'] . $_POST['name'])) {
			error('ファイル' . $_POST['name'] . 'はすでに存在します。');
		}

		//ファイル移動
		if (!rename(TARGET_DIR . $_GET['path'] . $_POST['name'], TARGET_DIR . $_POST['path'] . $_POST['name'])) {
			error('ファイル ' . TARGET_DIR . $_GET['path'] . $_POST['name'] . ' を移動できません。');
		}

		//リダイレクト
		header('Location: ' . HTTP_URL . MAIN_FILE . '?exec=' . $_POST['exec'] . '&path=' . str_replace('%2F', '/', urlencode($_GET['path'])));

		exit;
	}

	//ディレクトリ取得
	$directories = get_dir(TARGET_DIR);

	//ワンタイムトークン作成
	$token = token_create();

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ファイル移動</h2>\n";
	echo "<ul>\n";
	echo "<li>ファイル <code>" . TARGET_DIR . $_GET['path'] . $_GET['name'] . "</code> を移動します。</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "?mode=move_file&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($_GET['name']) . "\" method=\"post\">\n";
	echo "<fieldset>\n";
	echo "<legend>ファイル移動フォーム</legend>\n";
	echo "<input type=\"hidden\" name=\"token\" value=\"" . $token . "\" />\n";
	echo "<input type=\"hidden\" name=\"exec\" value=\"move_file\" />\n";
	echo "<input type=\"hidden\" name=\"name\" value=\"" . $_GET['name'] . "\" />\n";
	echo "<dl>\n";
	echo "<dt>起動先</dt>\n";
	echo "<dd>\n";
	echo "<select name=\"path\">\n";
	echo "<option name=\"\">/</option>\n";

	foreach ($directories as $directory) {
		$directory = preg_replace('/^' . preg_quote(TARGET_DIR, '/') . '/', '', $directory);

		echo "<option name=\"" . $directory . "\">/" . $directory . "</option>\n";
	}

	echo "</select>\n";
	echo "</dd>\n";
	echo "</dl>\n";
	echo "<p><input type=\"submit\" value=\"移動する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";

	print_footer();

	return;
}

/* ディレクトリ移動 */
function admin_move_directory()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}
	if (!isset($_GET['name']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['name']) or preg_match('/\.\.\//', $_GET['name'])) {
		$_GET['name'] = null;
	}

	if (isset($_POST['exec']) and $_POST['exec'] == 'move_directory') {
		//ワンタイムトークン比較
		if (!token_check()) {
			error('不正なアクセスです。');
		}

		//入力データ検証
		if ($_POST['path'] != '' and !preg_match('/' . PATH_CHARACTER . '/', $_POST['path'])) {
			error('パスは半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('パスの入力内容が不正です。');
		}
		if ($_POST['name'] == '') {
			error('ディレクトリ名が入力されていません。');
		} elseif (!preg_match('/' . PATH_CHARACTER . '/', $_POST['name'])) {
			error('ディレクトリ名は半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['name'])) {
			error('ディレクトリ名の入力内容が不正です。');
		} elseif (mb_strlen($_POST['name'], 'UTF-8') > 255) {
			error('ディレクトリ名は255文字以内で入力してください。');
		}
		if (is_dir(TARGET_DIR . $_POST['path'] . $_POST['name'])) {
			error('ディレクトリ' . $_POST['name'] . 'はすでに存在します。');
		}

		//ディレクトリ移動
		if (!rename(TARGET_DIR . $_GET['path'] . $_POST['name'], TARGET_DIR . $_POST['path'] . $_POST['name'])) {
			error('ディレクトリ ' . TARGET_DIR . $_GET['path'] . $_POST['name'] . ' を移動できません。');
		}

		//リダイレクト
		header('Location: ' . HTTP_URL . MAIN_FILE . '?exec=' . $_POST['exec'] . '&path=' . str_replace('%2F', '/', urlencode($_GET['path'])));

		exit;
	}

	//ディレクトリ取得
	$directories = get_dir(TARGET_DIR);

	//ワンタイムトークン作成
	$token = token_create();

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ディレクトリ移動</h2>\n";
	echo "<ul>\n";
	echo "<li>ディレクトリ <code>" . TARGET_DIR . $_GET['path'] . preg_replace('/\/$/', '', $_GET['name']) . "/</code> を移動します。</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "?mode=move_directory&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($_GET['name']) . "\" method=\"post\">\n";
	echo "<fieldset>\n";
	echo "<legend>ディレクトリ移動フォーム</legend>\n";
	echo "<input type=\"hidden\" name=\"token\" value=\"" . $token . "\" />\n";
	echo "<input type=\"hidden\" name=\"exec\" value=\"move_directory\" />\n";
	echo "<input type=\"hidden\" name=\"name\" value=\"" . $_GET['name'] . "\" />\n";
	echo "<dl>\n";
	echo "<dt>起動先</dt>\n";
	echo "<dd>\n";
	echo "<select name=\"path\">\n";
	echo "<option name=\"\">/</option>\n";

	foreach ($directories as $directory) {
		$directory = preg_replace('/^' . preg_quote(TARGET_DIR, '/') . '/', '', $directory);

		echo "<option name=\"" . $directory . "\">/" . $directory . "</option>\n";
	}

	echo "</select>\n";
	echo "</dd>\n";
	echo "</dl>\n";
	echo "<p><input type=\"submit\" value=\"移動する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";

	print_footer();

	return;
}

/* ファイル削除 */
function admin_delete_file()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}
	if (!isset($_GET['name']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['name']) or preg_match('/\.\.\//', $_GET['name'])) {
		$_GET['name'] = null;
	}

	if (isset($_POST['exec']) and $_POST['exec'] == 'delete_file') {
		//ワンタイムトークン比較
		if (!token_check()) {
			error('不正なアクセスです。');
		}

		//入力データ検証
		if ($_POST['path'] != '' and !preg_match('/' . PATH_CHARACTER . '/', $_POST['path'])) {
			error('パスは半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('パスの入力内容が不正です。');
		}
		if ($_POST['name'] == '') {
			error('ファイル名が入力されていません。');
		} elseif (!preg_match('/' . PATH_CHARACTER . '/', $_POST['name'])) {
			error('ファイル名は半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['name'])) {
			error('ファイル名の入力内容が不正です。');
		} elseif (mb_strlen($_POST['name'], 'UTF-8') > 255) {
			error('ファイル名は255文字以内で入力してください。');
		}

		//ファイル削除
		if (!unlink(TARGET_DIR . $_POST['path'] . $_POST['name'])) {
			error('ファイル ' . TARGET_DIR . $_POST['path'] . $_POST['name'] . ' を削除できません。');
		}

		//リダイレクト
		header('Location: ' . HTTP_URL . MAIN_FILE . '?exec=' . $_POST['exec'] . '&path=' . str_replace('%2F', '/', urlencode($_POST['path'])));

		exit;
	}

	//ワンタイムトークン作成
	$token = token_create();

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ファイル削除</h2>\n";
	echo "<ul>\n";
	echo "<li>ファイル <code>" . TARGET_DIR . $_GET['path'] . $_GET['name'] . "</code> を削除します。</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "?mode=delete_file&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($_GET['name']) . "\" method=\"post\">\n";
	echo "<fieldset>\n";
	echo "<legend>ファイル削除フォーム</legend>\n";
	echo "<input type=\"hidden\" name=\"token\" value=\"" . $token . "\" />\n";
	echo "<input type=\"hidden\" name=\"exec\" value=\"delete_file\" />\n";
	echo "<input type=\"hidden\" name=\"path\" value=\"" . $_GET['path'] . "\" />\n";
	echo "<input type=\"hidden\" name=\"name\" value=\"" . $_GET['name'] . "\" />\n";
	echo "<p><input type=\"submit\" value=\"削除する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";

	print_footer();

	return;
}

/* ディレクトリ削除 */
function admin_delete_directory()
{
	//パラメータ検証
	if (!isset($_GET['path']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['path']) or preg_match('/\.\.\//', $_GET['path'])) {
		$_GET['path'] = null;
	}
	if (!isset($_GET['name']) or !preg_match('/' . PATH_CHARACTER . '/', $_GET['name']) or preg_match('/\.\.\//', $_GET['name'])) {
		$_GET['name'] = null;
	}

	if (isset($_POST['exec']) and $_POST['exec'] == 'delete_directory') {
		//ワンタイムトークン比較
		if (!token_check()) {
			error('不正なアクセスです。');
		}

		//入力データ検証
		if ($_POST['path'] != '' and !preg_match('/' . PATH_CHARACTER . '/', $_POST['path'])) {
			error('パスは半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['path'])) {
			error('パスの入力内容が不正です。');
		}
		if ($_POST['name'] == '') {
			error('ディレクトリ名が入力されていません。');
		} elseif (!preg_match('/' . PATH_CHARACTER . '/', $_POST['name'])) {
			error('ディレクトリ名は半角英数字で入力してください。');
		} elseif (preg_match('/\.\.\//', $_GET['name'])) {
			error('ディレクトリ名の入力内容が不正です。');
		} elseif (mb_strlen($_POST['name'], 'UTF-8') > 255) {
			error('ディレクトリ名は255文字以内で入力してください。');
		}

		//ディレクトリ削除
		if (!remove_dir(TARGET_DIR . $_POST['path'] . $_POST['name'])) {
			error('ディレクトリ ' . TARGET_DIR . $_POST['path'] . $_POST['name'] . ' を削除できません。');
		}

		//リダイレクト
		header('Location: ' . HTTP_URL . MAIN_FILE . '?exec=' . $_POST['exec'] . '&path=' . str_replace('%2F', '/', urlencode($_POST['path'])));

		exit;
	}

	//ワンタイムトークン作成
	$token = token_create();

	//データ表示
	print_header(CSS_FILE);

	echo "<div id=\"menu\">\n";
	echo "<h2>メニュー</h2>\n";
	echo "<ul>\n";
	echo "<li><a href=\"" . HTTP_URL . MAIN_FILE . "\">戻る</a></li>\n";
	echo "</ul>\n";
	echo "</div>\n";
	echo "<h2>ディレクトリ削除</h2>\n";
	echo "<ul>\n";
	echo "<li>ディレクトリ <code>" . TARGET_DIR . $_GET['path'] . $_GET['name'] . "</code> を削除します。</li>\n";
	echo "</ul>\n";
	echo "<form action=\"" . HTTP_URL . MAIN_FILE . "?mode=delete_directory&amp;path=" . urlencode($_GET['path']) . "&amp;name=" . urlencode($_GET['name']) . "\" method=\"post\">\n";
	echo "<fieldset>\n";
	echo "<legend>ディレクトリ削除フォーム</legend>\n";
	echo "<input type=\"hidden\" name=\"token\" value=\"" . $token . "\" />\n";
	echo "<input type=\"hidden\" name=\"exec\" value=\"delete_directory\" />\n";
	echo "<input type=\"hidden\" name=\"path\" value=\"" . $_GET['path'] . "\" />\n";
	echo "<input type=\"hidden\" name=\"name\" value=\"" . $_GET['name'] . "\" />\n";
	echo "<p><input type=\"submit\" value=\"削除する\" /></p>\n";
	echo "</fieldset>\n";
	echo "</form>\n";

	print_footer();

	return;
}

/* PHP設定確認 */
function admin_phpinfo()
{
	//設定表示
	phpinfo();

	return;
}

/* ログアウト */
function admin_logout()
{
	//セッション情報クリア
	$_SESSION['login'] = false;

	//認証ページ
	admin();

	return;
}

/* エラー表示 */
function error($message)
{
	print_header(CSS_FILE);

	echo "<p>$message</p>\n";

	print_footer();

	exit;
}

/* ヘッダー出力 */
function print_header($css = '', $js = '')
{
	echo "<?xml version=\"1.0\" encoding=\"" . SCRIPT_CHARSET . "\"?>\n";
	echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n";
	echo "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\" lang=\"ja\" dir=\"ltr\">\n";
	echo "<head>\n";
	echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . SCRIPT_CHARSET . "\" />\n";
	if ($css) {
		echo "<meta http-equiv=\"Content-Style-Type\" content=\"text/css\" />\n";
	}
	if ($js) {
		echo "<meta http-equiv=\"Content-Script-Type\" content=\"text/javascript\" />\n";
	}
	echo "<title>File Admin</title>\n";
	if ($css) {
		echo "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\" media=\"all\" />\n";
	}
	if ($js) {
		echo "<script type=\"text/javascript\">\n";
		echo "//<![CDATA[\n";
		echo "$js\n";
		echo "//]]>\n";
		echo "</script>\n";
	}
	echo "</head>\n";
	echo "<body>\n";
	echo "<h1>File Admin</h1>\n";

	return;
}

/* フッター出力 */
function print_footer()
{
	echo "<address><a href=\"http://www.php-labo.net/\">File Admin</a></address>\n";
	echo "</body>\n";
	echo "</html>\n";

	return;
}

/* セッション開始 */
function session()
{
	$info = parse_url(HTTP_URL);

	session_set_cookie_params(SESSION_LIFETIME, $info['path']);
	session_cache_limiter(SESSION_CACHE);
	session_start();
	session_regenerate_id(true);

	return;
}

/* データ正規化 */
function normalize()
{
	$_GET     = sanitize($_GET);
	$_POST    = sanitize($_POST);
	$_REQUEST = sanitize($_REQUEST);
	$_SERVER  = sanitize($_SERVER);
	$_COOKIE  = sanitize($_COOKIE);

	$_GET     = unify($_GET);
	$_POST    = unify($_POST);
	$_REQUEST = unify($_REQUEST);
	$_SERVER  = unify($_SERVER);
	$_COOKIE  = unify($_COOKIE);

	return;
}

/* ワンタイムトークン作成 */
function token_create()
{
	global $users;

	$token = session_id();

	$_SESSION['token'] = $token;

	return $token;
}

/* ワンタイムトークン比較 */
function token_check()
{
	global $users;

	if (isset($_REQUEST['token']) and isset($_SESSION['token']) and $_REQUEST['token'] == $_SESSION['token']) {
		return true;
	} else {
		return false;
	}
}

/* ワンタイムトークン破棄 */
function token_destroy()
{
	global $users;

	$_SESSION['token'] = '';

	return;
}

/* ファイル情報取得 */
function get_file($file)
{
	if (preg_match('/\.(gif|jpeg|jpg|jpe|png)$/i', $file)) {
		list($width, $height) = getimagesize($file);
	} else {
		$width  = 0;
		$height = 0;
	}

	$size = filesize($file);

	return array($width, $height, $size);
}

/* ディレクトリ取得 */
function get_dir($path)
{
	$files = array();

	if (!file_exists($path)) {
		return $files;
	}

	if ($dir = scandir($path)) {
		$tmp_directories = array();

		foreach ($dir as $data) {
			if ($data == '.' or $data == '..') {
				continue;
			}

			if (is_dir($path . $data)) {
				$tmp_directories[] = $data;
			}
		}

		$dir = $tmp_directories;
	}

	foreach ($dir as $data) {
		$files = array_merge($files, array($path . $data . '/'), get_dir($path . $data . '/'));
	}

	return $files;
}

/* ディレクトリ削除 */
function remove_dir($path)
{
	if (!file_exists($path)) {
		return true;
	}

	if ($dir = scandir($path)) {
		foreach ($dir as $data) {
			if ($data == '.' or $data == '..') {
				continue;
			}
			if (is_dir($path . $data)) {
				if (!remove_dir($path . $data . '/')) {
					return false;
				}
			} elseif (is_file($path . $data)) {
				if (!unlink($path . $data)) {
					return false;
				}
			}
		}
	} else {
		return false;
	}

	if (rmdir($path)) {
		return true;
	} else {
		return false;
	}
}

/* 不正データ削除 */
function sanitize($data)
{
	if (is_array($data)) {
		return array_map('sanitize', $data);
	}

	return str_replace("\0", '', $data);
}

/* 改行コード統一 */
function unify($data)
{
	if (is_array($data)) {
		return array_map('unify', $data);
	}

	$data = preg_replace("/\r?\n/", "\r", $data);
	$data = preg_replace("/\r/", "\n", $data);

	return $data;
}

?>
